
function [response_map, response_map_index] = POINT_RESPONSE_2(row, col, rows, cols, horses, scale_array, distmap, label, dir_edgepoint, sc_map, zero_response, response_map, response_map_index);

      
        scales_resp = zeros(1, length(scale_array) );
		
		for n3 = 1 : length(scale_array)
			scale_id = scale_array(n3)*10 - 6;
			
			parts_resp = zeros(1, 6);
			for n1 = [1 2 3 6 4 5]
				parts_resp_in_horses = zeros(1, length(horses));	
                part_id = n1;
				
				for n2 = 1: length(horses)
					horse = horses{n2};
					
                    % disp(['horse', num2str(n2), 'scale', num2str(scale_id), 'part_id', num2str(part_id) ]);
					if isempty(horse.cntr{scale_id, part_id, 1})
						parts_resp_in_horses(n2) = zero_response;
                        if n1 == 6
                            parts_resp_in_horses(n2) = Inf;
                        end
                    else
                        cur_tplt = horse.cntr{scale_id, part_id, 1};
                        	
						if n1 == 4 || n1 == 5
							cur_tplt(:, 1) = cur_tplt(:, 1) + row + pnt_b(1);
							cur_tplt(:, 2) = cur_tplt(:, 2) + col + pnt_b(2);
						else
							cur_tplt(:, 1) = cur_tplt(:, 1) + row;
							cur_tplt(:, 2) = cur_tplt(:, 2) + col;
						end
							
						if ( max(cur_tplt(:, 1))>rows || min(cur_tplt(:, 1))<1 || ...
							max(cur_tplt(:, 2))>cols || min(cur_tplt(:, 2))<1 )
							resp = Inf;
                        else
                            resp = chamfer_matching(cur_tplt, distmap, label, dir_edgepoint, sc_map);                               
                        end
                        
						parts_resp_in_horses(n2) = resp;
					end
                end
	      
				[part_min, min_index] = min(parts_resp_in_horses);
				parts_resp(n1) = part_min;

                if part_min == Inf          % if the minimal response of one part is Inf, break
                    break;
                end
				 	
				if n1 == 6
					pnt_b = horses{min_index(1)}.pnt_b{scale_id} - horses{min_index(1)}.pnt_a{scale_id};
				end
            end
			
            % gama = -0.5;
			scales_resp(n3) = sum( parts_resp );
		end
		
		min_resp = min(scales_resp);
		
		response_map_index = response_map_index + 1;
		response_map(response_map_index, :) = [row, col, min_resp ];
		
		