function [min_resp, min_tplt, min_ref, min_skel, min_cntr, min_row, min_col] = ...
			POINT_RESPONSE_3(row, col, rows, cols, horses, scale_array, ang_arr, distmap, label, dir_edgepoint, sc_map, zero_response, min_resp, min_tplt, min_ref, min_skel, min_cntr, min_row, min_col)
		
	for n0 = 1:length(scale_array)
		parts_resp = zeros(1, 6);
		parts_tplt = cell(1, 6);
        parts_ref  = cell(1, 6);
        parts_skel = cell(1, 6);
		parts_cntr = cell(1, 6);
        scale_id = scale_array(n0) * 10 - 6;

        for n1 = [1 2 3 6 4 5]
			horses_resp = zeros(1, length(horses));
			horses_tplt = cell(1, length(horses));
            horses_ref  = cell(1, length(horses));
            horses_skel = cell(1, length(horses));
			horses_cntr = cell(1, length(horses));
			part_id = n1;
			
            for n2 = 1:length(horses) 
                rotate_resp = zeros(1, length(ang_arr{n1}) );
                rotate_tplt = cell(1, length(ang_arr{n1}) );
                rotate_ref  = cell(1, length(ang_arr{n1}) );
                rotate_skel = cell(1, length(ang_arr{n1}) );
				rotate_cntr = cell(1, length(ang_arr{n1}) );
                horse = horses{n2};
				
				if isempty( horse.cntr{scale_id, part_id, 1} )
					if n1 == 6
                        horses_resp(n2) = Inf;			% part 6 missing is not permited.
					else
						horses_resp(n2) = zero_response;
                    end
				else
					for n3 = 1 : length( ang_arr{n1} )
						rotate_id = n3;
						tplt = horse.cntr{scale_id, part_id, rotate_id};
						skel = horse.skel{scale_id, part_id, rotate_id};
						cntr = horse.ori_cntr{scale_id, part_id, rotate_id};
						
						if n1 == 4 || n1 == 5 %#ok<ALIGN>
							tplt(:, 1) = tplt(:, 1) + row + pnt_b(1);
							tplt(:, 2) = tplt(:, 2) + col + pnt_b(2);
                            skel(:, 1) = skel(:, 1) + row + pnt_b(1);
							skel(:, 2) = skel(:, 2) + col + pnt_b(2);
							cntr(:, 1) = cntr(:, 1) + row + pnt_b(1);
							cntr(:, 2) = cntr(:, 2) + col + pnt_b(2);
						else
							tplt(:, 1) = tplt(:, 1) + row;
							tplt(:, 2) = tplt(:, 2) + col;	
							skel(:, 1) = skel(:, 1) + row;
							skel(:, 2) = skel(:, 2) + col;
							cntr(:, 1) = cntr(:, 1) + row;
							cntr(:, 2) = cntr(:, 2) + col;
                        end
                    
                        if ( max(tplt(:, 1))>rows || min(tplt(:, 1))<1 || ...
                            max(tplt(:, 2))>cols || min(tplt(:, 2))<1 )
                            resp = Inf;
                            ref = [];
                        else
                            [resp, ref] = chamfer_matching(tplt, distmap, label, dir_edgepoint, sc_map);    
                        end

                        rotate_resp(n3) = resp;
                        rotate_tplt{n3} = tplt;
                        rotate_ref{n3}  = ref;
                        rotate_skel{n3} = skel;
						rotate_cntr{n3} = cntr;
                    end
				
                    [ horses_resp(n2), rotate_min_index] = min(rotate_resp);
					horses_tplt{n2} = rotate_tplt{rotate_min_index(1)};    
                    horses_ref{n2}  = rotate_ref{rotate_min_index(1)};    
                    horses_skel{n2} = rotate_skel{rotate_min_index(1)};
					horses_cntr{n2} = rotate_cntr{rotate_min_index(1)};
                end
                
			end
			
			[ parts_resp(n1), horses_min_index ] = min(horses_resp);
			parts_tplt{n1} = horses_tplt{horses_min_index(1)};
            parts_ref{n1}  = horses_ref{horses_min_index(1)};
            parts_skel{n1} = horses_skel{horses_min_index(1)};
			parts_cntr{n1} = horses_cntr{horses_min_index(1)};
            
            if parts_resp(n1) == Inf
                break;
            end
            
			if n1 == 6
				pnt_b = horses{horses_min_index(1)}.pnt_b{scale_id} - horses{horses_min_index(1)}.pnt_a{scale_id};
			end
        end
		
        % min_resp = min_resp  * exp(-gama * (1 - scale_array(n0)));
		if isempty(min_resp)
			min_resp = parts_resp;
			min_tplt = parts_tplt;
            min_ref  = parts_ref;
            min_skel = parts_skel;
			min_cntr = parts_cntr;
            min_row = row;
            min_col = col;
		else
			if sum(parts_resp) < sum(min_resp)
				min_resp = parts_resp;
				min_tplt = parts_tplt;
                min_ref  = parts_ref;
                min_skel = parts_skel;
				min_cntr = parts_cntr;
                min_row = row;
                min_col = col;
			end
		end
	end
	
	
				
				
				
				
				
				
				
				
				
				
				
				