% MEANSHIFT script, use the mean-shift method and response on all sampled point to calculate the best A point on the 
% edge image.

% help_len = 1:(length(response_map)-1);
% pro_list =  1 ./ response_map( help_len, 3);
% 
% help_arr1 = response_map(help_len, 1);
% help_arr2 = response_map(help_len, 2);
% help_resp_map = [help_arr1'; help_arr2'];
% 
% mode = weight_mean_shift(help_resp_map, 22.5, 0.0001, pro_list', 100);
% 
% row = round(mode(1)); col = round(mode(2));


% help_len = 1 : (length(response_map) - 1);
% resp_list = response_map( help_len, 3 );
% [s, help_index] = sort(resp_list);
% 
% N = 100;
% help_arr = zeros(2, N);
% dis_list = zeros(1, N);
% for n = 1 : N
%     help_arr(1, n) = response_map( help_index(n), 1 );
%     help_arr(2, n) = response_map( help_index(n), 2 );
%     dis_list(n)    = response_map( help_index(n), 3 );
% end
% pro_list = pdf('Normal', dis_list, 0, 1);
% mode = weight_mean_shift(help_arr, 22.5, 0.0001, pro_list, 100);


function [local_max_rows, local_max_cols] = find_local_maximal(response_map, rows, cols)

pro_list = exp( -response_map(1:end, 3)/10 );

max_pro = sort(pro_list, 'descend');

temp_pro_map = zeros(rows, cols);
for n = 1 : length(response_map)
    temp_pro_map( response_map(n, 1), response_map(n, 2) ) = pro_list(n);
end

[local_max_rows, local_max_cols] = nonmaxsuppts(temp_pro_map, 30,  max(max_pro(2), 0.8)  );



